#include <stdio.h>
#include <iostream>
#include <string>
#include <vector>


using namespace std;


typedef vector<int> VI;
typedef vector< VI > VII;


const char outchar[] = {'#', '.'};
const int dx[] = {0, 0, 1, -1};
const int dy[] = {1, -1, 0, 0};


VII lab; //0 - wall, 1 - empty;
int w, h;


inline void my_assert(bool cond, const string& msg) {
	if (!cond) {
		cerr << "WRONG INPUT : ";
		cerr << msg << endl;		
		throw msg;
	}
}


int main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	cin >> h >> w;
	h++; w++;
	lab.resize(h+1);
	for (VII::iterator it = lab.begin(); it < lab.end(); it++) {
		it->resize(w+1);
	}
	for (int i = 1; i < h; i++) {
		my_assert(!cin.eof(), "Less strings than expected");
		string tmp;
		cin >> tmp;
		my_assert(tmp.length()+1 == w, "One of lines length does not equal declared W value");
		for (int j = 1; j < w; j++) {
			lab[i][j] = tmp[j-1] == '.';
		}
	}

	for (int i = 1; i < h; i++) {
		for (int j = 1; j < w; j++) {
			int k = 1;
			for (int t = 0; t < 4; t++) {
				k &= !lab[i+dy[t]][j+dx[t]];
			}
			cout << outchar[lab[i][j] || k];
		}
		cout << endl;
	}
	fclose(stdin);
	fclose(stdout);
}
